'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 5 January 2005 at 4:50:57 pm'!
Object subclass: #SystemShrinker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Shrinking'!

!SystemShrinker commentStamp: '<historical>' prior: 0!
This class is just a place to store system shrinking code.
The aim of this effort is to remove "Applications" while leaving Base Smalltalk and Morphic framework. "Applications" include eToys and all scripting support.
This version is for Squeak 3.7-5989-basic.
SystemShrinker shrink!


!FileList class methodsFor: 'file reader registration' stamp: 'jmv 12/1/2004 15:27'!
cleanObsoleteReaders
"
	FileList cleanObsoleteReaders
"
	(FileList registeredFileReaderClasses select: [ :each | each isObsolete ]) do: [ :each | 
		self unregisterFileReader: each ]! !


!Preferences class methodsFor: 'misc' stamp: 'jmv 12/25/2004 15:43'!
cleanUp
	| dict |
	dict _ DictionaryOfPreferences.
	
	(dict keys select: [ :each |
	(((dict at: each) instVarNamed: 'changeInformee') isKindOf: Behavior) and: [
		((dict at: each) instVarNamed: 'changeInformee') isObsolete ]]) do: [ :eachKey |
			dict removeKey: eachKey ].
		
	(dict keys select: [:each | (Smalltalk systemNavigation allCallsOn: each) isEmpty]) do: [ :eachKey |
			dict removeKey: eachKey ].
		
	dict _ self parameterAt: #PersonalDictionaryOfPreferences ifAbsent: [^ self].

	(dict keys select: [ :each |
	(((dict at: each) instVarNamed: 'changeInformee') isKindOf: Behavior) and: [
		((dict at: each) instVarNamed: 'changeInformee') isObsolete ]]) do: [ :eachKey |
			dict removeKey: eachKey ].
		
	(dict keys select: [:each | (Smalltalk systemNavigation allCallsOn: each) isEmpty]) do: [ :eachKey |
			dict removeKey: eachKey ].! !


!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/20/2004 21:03'!
afterRemovingCleanup
	
	"So that obsolete classes are garbage collected"
	MethodChangeRecord allInstancesDo: [:mcr | mcr noteNewMethod: nil].
	
	"Flush obsolete subclasses"
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect.
	
	SystemOrganization removeEmptyCategories.
	Smalltalk garbageCollect.
	
	"seems to take more than one try to gc all the weak refs in SymbolTable"
	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 10/27/2004 16:18'!
cleanUpEtoys
	Smalltalk removeNormalCruft.
	Smalltalk cleanUpUndoCommands.
	Flaps disableGlobalFlaps.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 10/27/2004 15:17'!
emptyWorldsOfSqueak
	ProjectViewMorph allInstancesDo:
		[:m | (m hasProperty: #deleteWorldsOfSqueak) ifTrue:
			[Project deletingProject: m project. m delete]].
	Project rebuildAllProjects.
	ScriptingSystem spaceReclaimed.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 1/5/2005 15:55'!
finalCleanup
	| oldDicts newDicts ss |
	Smalltalk recreateSpecialObjectsArray.
	FileList cleanObsoleteReaders.
	Preferences installHaloTheme: #iconicHaloSpecifications.
	Preferences cleanUp.
	DataStream cleanup.
	Vocabulary cleanup.
	
	Symbol rehash.  "40k"

	"So that obsolete classes are garbage collected"
	MethodChangeRecord allInstancesDo: [:mcr | mcr noteNewMethod: nil].
	
	"Flush obsolete subclasses"
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect.
	
	ss _ Set allSubInstances.
	'Rehashing all sets'
		displayProgressAt: Sensor cursorPoint from: 1 to: ss size during: [:bar | 1 to: ss size do: [:i | 
					bar value: i.
					(ss at: i) rehash]].
			
	SystemOrganization removeEmptyCategories.
	Smalltalk garbageCollect.
		'Rehashing method dictionaries . . .'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: MethodDictionary instanceCount
		during: [:bar |
			oldDicts _ MethodDictionary allInstances.
			newDicts _ Array new: oldDicts size.
			oldDicts withIndexDo: [:d :index | 
				bar value: index.
				newDicts at: index put: d rehashWithoutBecome.
			].
			oldDicts elementsExchangeIdentityWith: newDicts.
		].
	Smalltalk zapAllOtherProjects.
	self stuffFromPrepareReleaseImage.
	
	Smalltalk cleanOutUndeclared.	
	Smalltalk condenseSources.
	
	"seems to take more than one try to gc all the weak refs in SymbolTable"
	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 10/27/2004 15:25'!
remove3D
	Smalltalk discard3D.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 1/5/2005 16:50'!
removeAdditionalStuff
"This could be considered optional"
SystemOrganization removeCategoriesMatching: 'Movies*'.
Notification subclass: #ParserRemovedUnusedTemps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'.
SystemOrganization removeCategoriesMatching: '*Tests'.
SystemOrganization removeCategoriesMatching: 'Tests*'.
SystemOrganization removeCategoriesMatching: 'FFI*'.
SystemOrganization removeCategoriesMatching: 'SM*'.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/9/2004 20:02'!
removeEtoysAndMorphicApplications
	SystemOrganization removeSystemCategory: 'Morphic-Scripting Tiles'.
SystemOrganization removeSystemCategory: 'Morphic-Scripting-Tests'.
SystemOrganization removeSystemCategory: 'Morphic-Scripting Support'.
SystemOrganization removeSystemCategory: 'EToy-UserObjects'.
SystemOrganization removeSystemCategory: 'Morphic-Imported'.
SystemOrganization removeSystemCategory: 'Morphic-UserObjects'.
SystemOrganization removeSystemCategory: 'Morphic-Components Built'.

MorphicModel subclass: #ComponentLikeModel
	instanceVariableNames: 'pinSpecs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-ComponentsToKeep'.
SystemOrganization removeSystemCategory: 'Morphic-Components'.

SystemOrganization removeSystemCategory: 'Morphic-Tile Scriptors'.
SystemOrganization removeSystemCategory: 'Morphic-Stacks'.
SystemOrganization removeSystemCategory: 'Morphic-Experimental'.
SystemOrganization removeSystemCategory: 'Morphic-GeeMail'.
"SystemOrganization removeSystemCategory: 'Morphic-Postscript Filters'."
SystemOrganization removeSystemCategory: 'Morphic-Postscript Canvases'.
SystemOrganization removeSystemCategory: 'Morphic-Models'.
SystemOrganization removeSystemCategory: 'Morphic-Outliner'.
SystemOrganization removeSystemCategory: 'Morphic-Leds'.
SystemOrganization removeSystemCategory: 'Morphic-PDA'.
SystemOrganization removeSystemCategory: 'Morphic-GeeMail'.

SystemOrganization removeSystemCategory: 'UserObjects'.
SystemOrganization removeSystemCategory: 'Squeak-EToy-Download'.
SystemOrganization removeCategoriesMatching: 'Speech*'.
SystemOrganization removeCategoriesMatching: 'StarSqueak*'.
SystemOrganization removeCategoriesMatching: 'Nebraska*'.
SystemOrganization removeSystemCategory:  'Protocols-Etoy'.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/20/2004 20:49'!
removeExtraMorphicStuff
RectangleMorph subclass: #AbstractMediaEventMorph
	instanceVariableNames: 'startTimeInScore endTimeInScore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Basic'.
	
SystemOrganization removeSystemCategory:  'Morphic-Demo'.
SystemOrganization removeSystemCategory:  'Morphic-Books'.
SystemOrganization removeSystemCategory:  'Morphic-Undo'.
SystemOrganization removeCategoriesMatching: 'Balloon-MMFlash*'.

"Smalltalk removeClassNamed: #WiWPasteUpMorph."
Smalltalk removeClassNamed: #MarqueeMorph.
Smalltalk removeClassNamed: #JoystickMorph.
Smalltalk removeClassNamed: #ZASMCameraMarkMorph.
Smalltalk removeClassNamed: #ZASMScriptMorph.
Smalltalk removeClassNamed: #ZASMStepsMorph.
Smalltalk removeClassNamed: #ZoomAndScrollControllerMorph.
Smalltalk removeClassNamed: #ZoomAndScrollMorph.

Smalltalk removeClassNamed: #AnimatedImageMorph.
Smalltalk removeClassNamed: #FlexMorph.
Smalltalk removeClassNamed: #MultiuserTinyPaint.
Smalltalk removeClassNamed: #WebPageMorph! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/2/2004 21:41'!
removeFlapsAndSuch
"SystemOrganization removeSystemCategory: 'Morphic-Flaps'."
SystemOrganization removeSystemCategory: 'Morphic-PartsBin'.
SystemOrganization removeSystemCategory: 'Morphic-Navigators'.
SystemOrganization removeSystemCategory: 'Morphic-Palettes'.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/2/2004 21:32'!
removeOtherProjects
	"Remove all projects but the current one."
	ProjectView allInstancesDo: [:pv | pv controller closeAndUnscheduleNoTerminate].
	Project current setParent: Project current.
	MorphWorldView allInstancesDo: [:pv | pv topView controller closeAndUnscheduleNoTerminate].
	Smalltalk at: #Wonderland ifPresent:[:cls| cls removeActorPrototypesFromSystem].
	Player freeUnreferencedSubclasses.
	MorphicModel removeUninstantiatedModels.
	Utilities classPool at: #ScrapsBook put: nil.
	Utilities zapUpdateDownloader.
	ProjectHistory currentHistory initialize.
	Project rebuildAllProjects.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/2/2004 21:35'!
removeSomeEtoysClasses
	Smalltalk removeClassNamed: #ObjectRepresentativeMorph.
	Smalltalk removeClassNamed: #AllScriptsTool.
	Smalltalk removeClassNamed: #Viewer.
	Smalltalk removeClassNamed: #CategoryViewer.
	Smalltalk removeClassNamed: #ClassRepresentativeMorph.
	Smalltalk removeClassNamed: #ListViewLine.
	Smalltalk removeClassNamed: #MethodMorph.
	Smalltalk removeClassNamed: #MethodWithInterface.
	Smalltalk removeClassNamed: #PhraseWrapperMorph.
	Smalltalk removeClassNamed: #UniclassScript.
	Smalltalk removeClassNamed: #StandardViewer.
"	Smalltalk removeClassNamed: #Player."			"Es superclase de Component"
"	Smalltalk removeClassNamed: #Presenter."
	Smalltalk removeClassNamed: #ScriptActivationButton.
	Smalltalk removeClassNamed: #ScriptEditorMorph.
	Smalltalk removeClassNamed: #ScriptInstantiation.
	Smalltalk removeClassNamed: #ScriptStatusControl.
	Smalltalk removeClassNamed: #ScriptStatusLine.
	Smalltalk removeClassNamed: #ScriptableButton.
	Smalltalk removeClassNamed: #ScriptingDomain.
	Smalltalk removeClassNamed: #SearchingViewer.
	Smalltalk removeClassNamed: #SlotInformation.
	Smalltalk removeClassNamed: #UnscriptedCardPlayer.
	Smalltalk removeClassNamed: #UnscriptedPlayer.
	Smalltalk removeClassNamed: #UserScript.
	
Smalltalk removeClassNamed: #EtoyUpdatingThreePhaseButtonMorph.! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 12/2/2004 21:34'!
removeStuffFromDiscardOddsAndEnds

	SystemOrganization removeSystemCategory: 'System-Serial Port'.
	SystemOrganization removeSystemCategory: 'ST80-Symbols'.
"	SystemOrganization removeSystemCategory: 'System-Digital Signatures'."
	Form removeSelector: #edit.
	Smalltalk at: #FormView ifPresent:
		[:c | c compile: 'defaultControllerClass  ^ NoController'
			classified: 'controller access'].
	Smalltalk removeClassNamed: #FormEditorView.
	Smalltalk removeClassNamed: #FormEditor.
"	SystemOrganization removeSystemCategory: 'ST80-Paths'."
	"bit editor (remove Form editor first):"
	Form removeSelector: #bitEdit.
	Form removeSelector: #bitEditAt:scale:.
	StrikeFont removeSelector: #edit:.
	Smalltalk removeClassNamed: #FormButtonCache.
	Smalltalk removeClassNamed: #FormMenuController.
	Smalltalk removeClassNamed: #FormMenuView.
	Smalltalk removeClassNamed: #BitEditor.
	"inspector for Dictionaries of Forms"
	Dictionary removeSelector: #inspectFormsWithLabel:.
	SystemDictionary removeSelector: #viewImageImports.
	ScreenController removeSelector: #viewImageImports.
	Smalltalk removeClassNamed: #FormHolderView.
	Smalltalk removeClassNamed: #FormInspectView.
	"experimental hand-drawn character recoginizer:"
	ParagraphEditor removeSelector: #recognizeCharacters.
	ParagraphEditor removeSelector: #recognizer:.
	ParagraphEditor removeSelector: #recognizeCharactersWhileMouseIn:.
	Smalltalk removeClassNamed: #CharRecog.
	"experimental updating object viewer:"
	Object removeSelector: #evaluate:wheneverChangeIn:.
	Smalltalk removeClassNamed: #ObjectViewer.
	Smalltalk removeClassNamed: #ObjectTracer.
	"miscellaneous classes:"
	Smalltalk removeClassNamed: #Array2D.
	Smalltalk removeClassNamed: #DriveACar.
	Smalltalk removeClassNamed: #EventRecorder.
	Smalltalk removeClassNamed: #FindTheLight.
	Smalltalk removeClassNamed: #PluggableTest.
	Smalltalk removeClassNamed: #SystemMonitor.
	Smalltalk removeClassNamed: #DocLibrary.
	Smalltalk at: #SampledSound ifPresent: [:c |c initialize].
Preferences setButtonFontTo:	(StrikeFont familyName: #NewYork size: 12).
Preferences setFlapsFontTo:	(StrikeFont familyName: #NewYork size: 12).! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 1/5/2005 16:11'!
stuffFromPrepareReleaseImage
"Stuff taken from:"
	"SmalltalkImage current prepareReleaseImage"
	
	| projectChangeSetNames |

	Undeclared removeUnreferencedKeys.
	StandardScriptingSystem initialize.
	(Object classPool at: #DependentsFields) size > 1 ifTrue: [self error:'Still have dependents'].
	Undeclared isEmpty ifFalse: [self error:'Please clean out Undeclared'].

	Browser initialize.
	ScriptingSystem deletePrivateGraphics.  "?"
	
	"Delete all changesets except those currently used by existing projects."
	projectChangeSetNames _ Project allSubInstances collect: [:proj | proj changeSet name].
	ChangeSorter removeChangeSetsNamedSuchThat:
		[:cs | (projectChangeSetNames includes: cs) not].
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.
	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	"Remove existing player references"
	References keys do:[:k| References removeKey: k].  "?"

	Smalltalk garbageCollect.
	ScheduledControllers _ nil.
	Smalltalk garbageCollect.
	
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	Smalltalk obsoleteBehaviors isEmpty ifFalse:[self error:'Still have obsolete behaviors'].

	DataStream initialize.
	SmalltalkImage current fixObsoleteReferences.
	Smalltalk forgetDoIts.  "?"
	Smalltalk flushClassNameCache.  "?"
	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].
! !

!SystemShrinker class methodsFor: 'shrinking' stamp: 'jmv 10/27/2004 17:05'!
toBeChecked
	"Understand this stuff!!"
	
	"From #makeSqueaklandRelease"
	"Dependents mean that we're holding onto stuff"
	(Object classPool at: #DependentsFields) size > 1
		ifTrue: [self error: 'Still have dependents'].
	Smalltalk obsoleteBehaviors isEmpty
		ifFalse: [self error: 'Still have obsolete behaviors'].
	"Clear all server entries"
	ServerDirectory serverNames
		do: [:each | ServerDirectory removeServerNamed: each].
			
	"cosas tomadas de majorShrink?"! !

!SystemShrinker class methodsFor: 'public' stamp: 'jmv 1/5/2005 15:50'!
setSimplePreferences

Preferences setPreferencesFrom:

	#(	
		(annotationPanes true)
		(balloonHelpEnabled false)
		(balloonHelpInMessageLists false)
		(batchPenTrails noOpinion)
		(browseWithDragNDrop false)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(caseSensitiveFinds true)
		(classicNavigatorEnabled false)
		(clickOnLabelToEdit true)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(colorWhenPrettyPrinting false)
		(dragNDropWithAnimation false)
		(fenceEnabled noOpinion)
		(honorDesktopCmdKeys false)
		(ignoreStyleIfOnlyBold true)
		(mvcProjectsAllowed true)
		(noviceMode false)
		(personalizedWorldMenu false)
		(roundedMenuCorners false)
		(roundedWindowCorners false)
		(securityChecksEnabled noOpinion)
		(showProjectNavigator false)
		(showSharedFlaps false)
		(simpleMenus false)
		(timeStampsInMenuTitles false)
		
		(viewersInFlaps false)
		(swapControlAndAltKeys false)
		(useUndo false)
		(preserveTrash false)
		(classicNewMorphMenu true)
		(slideDismissalsToTrash false)
	).! !

!SystemShrinker class methodsFor: 'public' stamp: 'jmv 12/20/2004 20:47'!
shrink
	(self confirm: 'Do you want to shrink Squeak?
If so, please close all text windows and remove the Squeak logo, and start again.')
		ifFalse: [ ^self ].
		
	self setSimplePreferences.
	
	self emptyWorldsOfSqueak.
	self removeOtherProjects.
	self cleanUpEtoys.
	
	self remove3D.
	self removeStuffFromDiscardOddsAndEnds.
	self removeEtoysAndMorphicApplications.
	self removeSomeEtoysClasses.
	self removeAdditionalStuff.
	self removeFlapsAndSuch.
	self removeExtraMorphicStuff.
	
	self afterRemovingCleanup! !


!Vocabulary class methodsFor: 'class initialization' stamp: 'jmv 12/19/2004 10:13'!
cleanup
	| keysToRemove |
	AllStandardVocabularies isNil ifTrue: [^self].
	keysToRemove := Set new.
	AllStandardVocabularies keysAndValuesDo: [ :k :v |
		v class isObsolete ifTrue: [ keysToRemove add: k ] ].
	keysToRemove do: [ :k |
		AllStandardVocabularies removeKey: k ]! !

