'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 10 February 2005 at 8:13:20 pm'!
Smalltalk renameClassNamed: #MorphicModel as: #MorphWithModel!
Smalltalk renameClassNamed: #ComponentLikeModel as: #ComponentLikeMorph!

!MorphWithModel methodsFor: 'compilation' stamp: 'jmv 2/10/2005 20:07'!
nameFor: aMorph
	"Return the name of the slot containing the given morph or nil if that morph has not been named."

	| allNames start |
	allNames _ self class allInstVarNames.
	start _ MorphWithModel allInstVarNames size + 1.
	start to: allNames size do: [:i |
		(self instVarAt: i) == aMorph ifTrue: [^ allNames at: i]].
	^ nil
! !

!MorphWithModel methodsFor: 'compilation' stamp: 'jmv 2/10/2005 20:07'!
removeAll
	"Clear out all script methods and subpart instance variables in me.  Start over."
	"self removeAll"
	"MorphWithModel2 removeAll"

self class == MorphWithModel ifTrue: [^ self].	"Must be a subclass!!"
self class removeCategory: 'scripts'.
self class instVarNames do: [:nn | self class removeInstVarName: nn].! !


!MorphWithModel class methodsFor: 'compiling' stamp: 'jmv 2/10/2005 20:06'!
acceptsLoggingOfCompilation
	"Dont log sources for my automatically-generated subclasses.  Can easily switch this back when it comes to deal with Versions, etc."

	^ self == MorphWithModel or: [(name last isDigit) not]! !

!MorphWithModel class methodsFor: 'compiling' stamp: 'jmv 2/10/2005 20:07'!
wantsChangeSetLogging
	"Log changes for MorphWithModel itself and for things like PlayWithMe2, but not for automatically-created subclasses like MorphWithModel1, MorphWithModel2, etc."

	^ self == MorphWithModel or:
		[(self class name beginsWith: 'MorphWithModel') not]! !

!MorphWithModel class methodsFor: 'housekeeping' stamp: 'jmv 2/10/2005 20:06'!
removeUninstantiatedModels
	"With the user's permission, remove the classes of any models that have neither instances nor subclasses."
	"MorphWithModel removeUninstantiatedModels"

	| candidatesForRemoval ok |
	Smalltalk garbageCollect.
	candidatesForRemoval _
		MorphWithModel subclasses select: [:c |
			(c instanceCount = 0) and: [c subclasses size = 0]].
	candidatesForRemoval do: [:c |
		ok _ self confirm: 'Are you certain that you
want to delete the class ', c name, '?'.
		ok ifTrue: [c removeFromSystem]].
! !


!SystemDictionary methodsFor: 'shrinking' stamp: 'jmv 2/10/2005 20:12'!
computeImageSegmentation
	"Smalltalk computeImageSegmentation"
"Here's how the segmentation works:
For each partition, we collect the classes involved, and also all messages no longer used in the absence of this partition.  We start by computing a 'Miscellaneous' segment of all the unused classes in the system as is."
	|  partitions unusedCandM newClasses expandedCandM |
	partitions _ Dictionary new.
	unusedCandM _ Smalltalk unusedClassesAndMethodsWithout: {{}. {}}.
	partitions at: 'Miscellaneous' put: unusedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'VMConstruction-*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'VMConstruction' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'ST80-*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'ST80' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Morphic-Games') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Games' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Morphic-Remote') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Nebraska' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | ((SystemOrganization categoriesMatching: 'Network-*')
				copyWithoutAll: #('Network-Kernel' 'Network-Url' 'Network-Protocols' 'Network-ObjectSocket')) do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Network' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Balloon3D-*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Balloon3D' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'FFI-*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'FFI' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Genie-*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Genie' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Speech-*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Speech' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | #('Morphic-Components') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	newClasses _ newClasses copyWithoutAll: #(ComponentLikeMorph).
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Components' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | #('Sound-Scores' 'Sound-Interface') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	newClasses _ newClasses , #(WaveletCodec Sonogram FWT AIFFFileReader).
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Sound' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | ((SystemOrganization categoriesMatching: 'Tools-*') copyWithout: 'Tools-Menus') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	newClasses _ newClasses copyWithoutAll: #(Debugger Inspector ContextVariablesInspector SyntaxError ChangeSet ChangeRecord ClassChangeRecord ChangeList VersionsBrowser).
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Tools' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Balloon-MMFlash*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	newClasses _ newClasses , #(ADPCMCodec).
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'Flash' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Balloon-TrueType*') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'TrueType' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	newClasses _ Array streamContents:
		[:s | (SystemOrganization categoriesMatching: 'Graphics-Files') do:
			[:cat | (SystemOrganization superclassOrder: cat) do: [:c | s nextPut: c name]]].
	expandedCandM _ Smalltalk unusedClassesAndMethodsWithout: {unusedCandM first asArray , newClasses. unusedCandM second}.
	partitions at: 'GraphicFiles' put:
		{(expandedCandM first copyWithoutAll: unusedCandM first) addAll: newClasses; yourself.
		expandedCandM second copyWithoutAll: unusedCandM second}.
	unusedCandM _ expandedCandM.

	#(	#AliceConstants 'Balloon3D'
		#B3DEngineConstants 'Balloon3D'
		#WonderlandConstants 'Balloon3D'
		#FFIConstants 'FFI'
		#KlattResonatorIndices 'Speech') pairsDo:
			[:poolName :part | (partitions at: part) first add: poolName].


	partitions keysDo: [:k | k = 'Miscellaneous' ifFalse:
		[(partitions at: 'Miscellaneous') first removeAllFoundIn:
	(partitions at: k) first]].
	^ partitions! !

MorphicTransform class removeSelector: #fromRemoteCanvasEncoding:!

!MorphicTransform reorganize!
('accessing' angle inverseTransformation offset scale withAngle: withOffset: withScale:)
('transformations' composedWith: invert: invertBoundsRect: invertRect: transform: transformBoundsRect:)
('private' setAngle: setOffset: setOffset:angle:scale: setScale:)
('initialize' setIdentiy)
('testing' isIdentity isMorphicTransform isPureTranslation)
('transforming points' globalPointToLocal: localPointToGlobal:)
('converting' asMatrixTransform2x3 asMorphicTransform)
('printing' printOn:)
('composing' composedWithLocal:)
!

MatrixTransform2x3 class removeSelector: #fromRemoteCanvasEncoding:!

!MatrixTransform2x3 reorganize!
('accessing' at: at:put: inverseTransformation offset offset:)
('comparing' = hash)
('composing' composedWithLocal: composedWithLocal:into:)
('converting' asMatrixTransform2x3)
('element access' a11 a11: a12 a12: a13 a13: a21 a21: a22 a22: a23 a23:)
('initialize' setIdentiy)
('objects from disk' byteSize bytesPerBasicElement bytesPerElement restoreEndianness writeOn:)
('printing' printOn:)
('testing' isIdentity isMatrixTransform2x3 isPureTranslation)
('transforming points' globalPointToLocal: invertPoint: localPointToGlobal: transformDirection: transformPoint:)
('transforming rects' globalBounds:toLocal: globalBoundsToLocal: localBounds:toGlobal: localBoundsToGlobal:)
('private' setAngle: setOffset: setScale:)
!

CompositeTransform class removeSelector: #fromRemoteCanvasEncoding:!
DisplayTransform class removeSelector: #fromRemoteCanvasEncoding:!

!CompositeTransform reorganize!
('initialization' composedWith: globalTransform:localTransform:)
('testing' isCompositeTransform isIdentity isPureTranslation)
('transformations' invert: transform:)
('accessing' angle inverseTransformation offset scale)
('transforming points' globalPointToLocal: localPointToGlobal:)
('converting' asCompositeTransform asMatrixTransform2x3 asMorphicTransform)
!


!DisplayTransform reorganize!
('initialize' setIdentity)
('accessing' inverseTransformation)
('testing' isCompositeTransform isIdentity isMatrixTransform2x3 isMorphicTransform isPureTranslation)
('composing' composedWithGlobal: composedWithLocal:)
('transforming points' globalPointToLocal: globalPointsToLocal: invertBoundsRect: localPointToGlobal: localPointsToGlobal:)
('transforming rects' globalBoundsToLocal: localBoundsToGlobal: sourceQuadFor:)
('converting' asCompositeTransform asMatrixTransform2x3)
!

